#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.14.2
 Author:         Kanashius

 Script Function:
	A Manager for TV-Shows.

#ce ----------------------------------------------------------------------------
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <WinAPI.au3>
#include <SQLite.au3>
#include <GDIPlus.au3>
#include <GuiScrollBars.au3>
#include <StructureConstants.au3>
#include <StaticConstants.au3>
#include <EditConstants.au3>
#include <ComboConstants.au3>
#include <GuiListBox.au3>
#include <GuiComboBoxEx.au3>
#include <GuiListView.au3>
#include "include\Json.au3"
Opt("GuiOnEventMode",1)
AutoItSetOption("GUIResizeMode",$GUI_DOCKALL)

;General
Global $sPathIni="Data\settings.ini"
Global $sTitle="TV-Show Manager"
Global $iDefaultWidth=IniRead($sPathIni,"general","iWidth",@DesktopWidth),$iDefaultHeight=IniRead($sPathIni,"general","iHeight",@DesktopHeight)
Global $iDefaultX=IniRead($sPathIni,"general","iX",-1),$iDefaultY=IniRead($sPathIni,"general","iY",-1)
Global $bUseTMDB=true,$sSqlDllPath="Data\sqlite3.dll",$hMainDatabase,$sMainDatabaseFile="Data\TVShowDatabase.sqlite"
Global $arSearchItems[0][10];ID,Name,Poster,description,CtrlPic,CtrlName,CtrlDesc,hBitmap,HoverLabel,PosterWidth
Global $bMainListViewBeingFilled=false,$bMainListViewStopFilling=false,$iDetailedInfoRating=0,$iDetailedInfoFontSize=15
Global $arStarPoints=[[10,0],[1/2,0],[5/8,3/8],[1,3/8],[6/8,5/8],[7/8,1],[1/2,6/8],[1/8,1],[2/8,5/8],[0,3/8],[3/8,3/8]]
Global $hGraphicsMainGui,$hBrushMainGui,$hDetailedInfoBitmapPosterOrig,$iDetailedInfoBitmapPosterOrigWidth,$iDetailedInfoBitmapPosterOrigHeight
;TheMovieDatabase
Global $sTMDB_APIKEY=IniRead($sPathIni,"general","TheMoveDBApiKey","");Add your The Movie Database API-Key in the SETTINGSFILE!!!!!!!!!!!!!!!!!
Global $sTMDB_SEARCHTVSHOW="https://api.themoviedb.org/3/search/tv?api_key="&$sTMDB_APIKEY&"&language=de&query=%s"
Global $sTMDB_GETTVSHOWINFO="https://api.themoviedb.org/3/tv/%s?api_key="&$sTMDB_APIKEY&"&language=de"
Global $sTMDB_GETIMAGE="https://image.tmdb.org/t/p/w500%s"
If $sTMDB_APIKEY="" Then $bUseTMDB=false
;MainGuiHandles
Global $hMainGui,$iMainGui_GenreList,$sMainListviewFields="ID|Title|Season count|Episode count|Is in Production|Last season|Last episode|Last seen season|Last seen episode|Rating"
Global $iPosterHeight,$iStarHeight,$iMainGui_DetailedInfoWidth,$iDetailedInfoX
;MainGuiResizing
Global $iMainGui_GenreListWidth=300
;AddNewTVShow Handles
Global $hAddEditTVShowGui,$iAddEditTVShowGui_SearchInput,$iAddEditTVShowGui_SearchButton,$iAddEditTVShowGui_AbortSearchButton,$hSearchGui,$iSearchGuiItemHeight=250,$iSearchGuiItemVertSpace=5,$arLastWatchedData[0],$_AddEditTVShow_binImageData
Global $iAddEditTVShowGui_LabelID,$iAddEditTVShowGui_InputID,$iAddEditTVShowGui_LabelTitle,$iAddEditTVShowGui_InputTitle,$iAddEditTVShowGui_LabelSeasonCount,$iAddEditTVShowGui_InputSeasonCount,$iAddEditTVShowGui_LabelEpisodeCount
Global $iAddEditTVShowGui_InputEpisodeCount,$iAddEditTVShowGui_LabelTMDBID,$iAddEditTVShowGui_CheckTMDBID,$iAddEditTVShowGui_InputTMDBID,$iAddEditTVShowGui_ButtonTMDBID,$iAddEditTVShowGui_LabelInProduction,$iAddEditTVShowGui_ComboInProduction
Global $iAddEditTVShowGui_LabelLastSeenSeason,$iAddEditTVShowGui_ComboLastSeenSeason,$iAddEditTVShowGui_LabelLastSeenEpisode,$iAddEditTVShowGui_ComboLastSeenEpisode,$iAddEditTVShowGui_LabelDescription,$iAddEditTVShowGui_EditDescription
Global $iAddEditTVShowGui_LabelSeasonInfo,$iAddEditTVShowGui_ListViewSeasonInfo,$iAddEditTVShowGui_ListGenre,$iAddEditTVShowGui_InputGenreAdd,$iAddEditTVShowGui_ButtonGenreAdd,$iAddEditTVShowGui_LabelRating,$iAddEditTVShowGui_ComboRating
Global $iAddEditTVShowGui_ButtonCreateUpdate,$iAddEditTVShowGui_ButtonCancel,$iAddEditTVShowGui_LabelPicChange,$iAddEditTVShowGui_InputPicPathUrl,$iAddEditTVShowGui_ButtonPicChange,$iAddEditTVShowGui_ButtonPicPathChange,$iAddEditTVShowGui_PicPoster
;AddNewTVShow States
Global $bAddEditTVShowGuiOpen=false,$iAddEditTVShowWinDiff=40,$bShowSearchResults=false
;AddNewTVShowGuiResizing
Global $iAddEditNewTVShow_SearchButtonWidth=100

_init()

$hMainGui=GUICreate($sTitle,$iDefaultWidth,$iDefaultHeight,$iDefaultX,$iDefaultY,BitOR($WS_MINIMIZEBOX,$WS_CAPTION,$WS_POPUP,$WS_SYSMENU,$WS_SIZEBOX,$WS_MAXIMIZEBOX))
GUISetBkColor(0xF0F0F0,$hMainGui)
$hGraphicsMainGui = _GDIPlus_GraphicsCreateFromHWND($hMainGui)
$hBrushMainGui = _GDIPlus_BrushCreateSolid(0xFFFFFF00)
$hBrushMainGuiDefaultColor = _GDIPlus_BrushCreateSolid(0xFFF0F0F0)
;$hMainGui_Menu_File=GUICtrlCreateMenu("File")
$hMainGui_Menu_Edit=GUICtrlCreateMenu("Edit")
$hMainGui_Menu_AddEditTVShow=GUICtrlCreateMenuItem("Add new TVShow",$hMainGui_Menu_Edit)
GUICtrlSetOnEvent(-1,"_AddEditTVShowMenu")
$hMainGui_Menu_SearchEpisodeUpdates=GUICtrlCreateMenuItem("Search for new Episodes",$hMainGui_Menu_Edit)
GUICtrlSetOnEvent(-1,"_AutoSearchForNewEpisodes")
If NOT $bUseTMDB Then GUICtrlSetState($hMainGui_Menu_SearchEpisodeUpdates,$GUI_DISABLE)
$iMainGui_GenreList=GUICtrlCreateList("All",0,0,5,5,BitOr($LBS_SORT, $WS_HSCROLL, $WS_VSCROLL, $WS_BORDER, $LBS_MULTIPLESEL))
$iMainGui_TVShowList=GUICtrlCreateListView($sMainListviewFields,0,0,5,5)
$iMainGui_TVShowList_ContextMenu=GUICtrlCreateContextMenu($iMainGui_TVShowList)
GUICtrlCreateMenuItem("Delete",$iMainGui_TVShowList_ContextMenu)
GUICtrlSetOnEvent(-1,"_MainGui_DeleteSelectedTVShow")
$iMainGui_DetailedLabelTitle=GUICtrlCreateLabel("",5,5,5,5,$SS_CENTER)
GUICtrlSetFont(-1,$iDetailedInfoFontSize)
$iMainGui_DetailedEditDescription=GUICtrlCreateEdit("",5,5,5,5,BitOR($ES_MULTILINE,$ES_AUTOVSCROLL,$ES_READONLY))
$iMainGui_DetailedLabelInProduction=GUICtrlCreateLabel("",5,5,5,5,$SS_CENTER)
GUICtrlSetFont(-1,$iDetailedInfoFontSize)
$iMainGui_DetailedLabelLatestSeason=GUICtrlCreateLabel("",5,5,5,5,$SS_CENTER)
GUICtrlSetFont(-1,$iDetailedInfoFontSize)
$iMainGui_DetailedLabelLatestEpisode=GUICtrlCreateLabel("",5,5,5,5,$SS_CENTER)
GUICtrlSetFont(-1,$iDetailedInfoFontSize)
$iMainGui_DetailedLabelLastSeenSeason=GUICtrlCreateLabel("",5,5,5,5,$SS_CENTER)
GUICtrlSetFont(-1,$iDetailedInfoFontSize)
$iMainGui_DetailedLabelLastSeenEpisode=GUICtrlCreateLabel("",5,5,5,5,$SS_CENTER)
GUICtrlSetFont(-1,$iDetailedInfoFontSize)
$iMainGui_DetailedListGenre=GUICtrlCreateList("",5,5,5,5,BitOR($LBS_NOSEL,$LBS_STANDARD))
GUISetOnEvent($GUI_EVENT_CLOSE,"_shutdown",$hMainGui)
_updateWinSize($hMainGui)
GUIRegisterMsg($WM_SIZE,"_updateWinSize")
GUISetOnEvent($GUI_EVENT_RESIZED, '_updateMainGui', $hMainGui)
GUISetOnEvent($GUI_EVENT_MINIMIZE, '_updateMainGui', $hMainGui)
GUISetOnEvent($GUI_EVENT_MAXIMIZE, '_updateMainGui', $hMainGui)
GUISetOnEvent($GUI_EVENT_RESTORE, '_updateMainGui', $hMainGui)
GUIRegisterMsg($WM_VSCROLL, "WM_VSCROLL")
GUIRegisterMsg($WM_COMMAND, "WM_COMMAND")
GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")
GUIRegisterMsg($WM_PAINT, "WM_PAINT")
_loadGenresToList($iMainGui_GenreList)
GUISetState(@SW_SHOW,$hMainGui)
If IniRead($sPathIni,"general","Maximized","true")="true" Then GUISetState(@SW_MAXIMIZE,$hMainGui)
$iIndex=_GUICtrlListBox_FindString($iMainGui_GenreList,"All")
_GUICtrlListBox_SelItemRange($iMainGui_GenreList,$iIndex,$iIndex,true)
_updateListviewEntrys()

While Sleep(10)
WEnd

Func _AutoSearchForNewEpisodes()
	local $aData,$iRows,$iCols
	local $sSelect="SELECT id,TMDBID,SeasonCount,EpisodeCount FROM TVShow WHERE InProduction='true';"
	_SQLite_GetTable2d($hMainDatabase,$sSelect,$aData,$iRows,$iCols)
	For $i=1 To UBound($aData)-1 step 1
		$oJsonInfo=_TMDB_GetInfo($aData[$i][1])
		If Json_IsObject($oJsonInfo) Then
			If Int(Json_ObjGet($oJsonInfo,"number_of_seasons"))>Int($aData[$i][2]) or Int(Json_ObjGet($oJsonInfo,"number_of_episodes"))>Int($aData[$i][3]) Then
				local $sSeasonCount=Json_ObjGet($oJsonInfo,"number_of_seasons")
				local $sEpisodeCount=Json_ObjGet($oJsonInfo,"number_of_episodes")
				local $sInProd=Json_ObjGet($oJsonInfo,"in_production")
				_SQLite_Exec($hMainDatabase,"UPDATE TVShow SET SeasonCount='"&$sSeasonCount&"',EpisodeCount='"&$sEpisodeCount&"',InProduction='"&$sInProd&"' WHERE id='"&$aData[$i][0]&"';")
				_SQLite_Exec($hMainDatabase,"DELETE FROM TVShowSeasonInfo WHERE TVShowID='"&$aData[$i][0]&"'")
				local $arSeasons=Json_ObjGet($oJsonInfo,"seasons")
				local $sSeasonUpdateString="BEGIN TRANSACTION;"
				For $j=0 To UBound($arSeasons)-1 Step 1
					$sSeasonUpdateString&="INSERT INTO TVShowSeasonInfo(TVShowID,SeasonNumber,EpisodeCount) VALUES('"&$aData[$i][0]&"','"&Json_ObjGet($arSeasons[$j],"season_number")&"','"&Json_ObjGet($arSeasons[$j],"episode_count")&"');"
				Next
				$sSeasonUpdateString&="COMMIT;"
				_SQLite_Exec($hMainDatabase,$sSeasonUpdateString)
			EndIf
		EndIf
	Next
	_updateListviewEntrys()
EndFunc

Func _MainGui_DeleteSelectedTVShow()
	$iIndex=_GUICtrlListView_GetSelectedIndices($iMainGui_TVShowList)
	If $iIndex<>"" Then
		If MsgBox(4,"Hint","Do you really want to delete the tv-show: "&_GUICtrlListView_GetItemText($iMainGui_TVShowList,Int($iIndex),1)&"?")=6 Then
			_DeleteTVShowFromDatabase(_GUICtrlListView_GetItemText($iMainGui_TVShowList,Int($iIndex),0))
			_updateListviewEntrys()
		EndIf
	EndIf
EndFunc

Func _drawPoster($iPosX,$iPosY,$iWidth,$iHeight)
	_GDIPlus_GraphicsFillRect($hGraphicsMainGui,$iPosX,$iPosY,$iWidth,$iHeight,$hBrushMainGuiDefaultColor)
	If $hDetailedInfoBitmapPosterOrig<>0 Then
		local $iScale=$iWidth/$iDetailedInfoBitmapPosterOrigWidth>$iHeight/$iDetailedInfoBitmapPosterOrigHeight?$iHeight/$iDetailedInfoBitmapPosterOrigHeight:$iWidth/$iDetailedInfoBitmapPosterOrigWidth
		$hScaledBitmap=_GDIPlus_ImageScale($hDetailedInfoBitmapPosterOrig,$iScale,$iScale)
		$iPosX+=($iWidth-_GDIPlus_ImageGetWidth($hScaledBitmap))/2
		$iPosY+=($iHeight-_GDIPlus_ImageGetHeight($hScaledBitmap))/2
		_GDIPlus_GraphicsDrawImage($hGraphicsMainGui,$hScaledBitmap,$iPosX,$iPosY)
		_GDIPlus_BitmapDispose($hScaledBitmap)
	EndIf
EndFunc

Func _drawRating($iPosX,$iPosY,$iWidth,$iHeight)
	_GDIPlus_GraphicsFillRect($hGraphicsMainGui,$iPosX,$iPosY,$iWidth,$iHeight,$hBrushMainGuiDefaultColor)
	local $iMinSize=$iWidth/5>$iHeight?$iHeight:$iWidth/5
	For $i=0 To $iDetailedInfoRating-1 step 1
		_GDIPlus_GraphicsFillPolygon($hGraphicsMainGui,_getStarArray($iMinSize,$iPosX+$i*$iMinSize,$iPosY),$hBrushMainGui)
	Next
EndFunc

Func _getStarArray($iSize,$iXPos,$iYPos)
	local $arStarPointsScaled[UBound($arStarPoints)][2]
	$arStarPointsScaled[0][0]=$arStarPoints[0][0]
	For $i=1 To UBound($arStarPoints)-1 step 1
		$arStarPointsScaled[$i][0]=$arStarPoints[$i][0]*$iSize+$iXPos
		$arStarPointsScaled[$i][1]=$arStarPoints[$i][1]*$iSize+$iYPos
	Next
	return $arStarPointsScaled
EndFunc

Func _MainGui_ShowDetailedSeriesInfo($sSeriesID)
	If $sSeriesID="" or $sSeriesID<0 Then
		GUICtrlSetData($iMainGui_DetailedLabelTitle,"")
		GUICtrlSetData($iMainGui_DetailedEditDescription,"")
		GUICtrlSetData($iMainGui_DetailedLabelInProduction,"")
		GUICtrlSetData($iMainGui_DetailedLabelLatestSeason,"")
		GUICtrlSetData($iMainGui_DetailedLabelLatestEpisode,"")
		GUICtrlSetData($iMainGui_DetailedLabelLastSeenSeason,"")
		GUICtrlSetData($iMainGui_DetailedLabelLastSeenEpisode,"")
		$iDetailedInfoRating=0
		_GDIPlus_BitmapDispose($hDetailedInfoBitmapPosterOrig)
		$hDetailedInfoBitmapPosterOrig=0
		While _GUICtrlListBox_GetCount($iMainGui_DetailedListGenre)>0
			_GUICtrlListBox_DeleteString($iMainGui_DetailedListGenre,0)
		WEnd
	Else
		_GDIPlus_BitmapDispose($hDetailedInfoBitmapPosterOrig)
		local $aData,$iRows,$iCols
		local $sSelect="SELECT t.title,t.seasonCount,t.episodeCount,t.tmdbId,t.inProduction,u.lastSeenSeason,u.lastSeenEpisode,u.rating,t.description,t.imageBinary FROM TVShow t JOIN Userdata u ON t.id=u.tvShowID WHERE t.id='"&$sSeriesID&"';"
		_SQLite_GetTable2d($hMainDatabase,$sSelect,$aData,$iRows,$iCols)
		If UBound($aData)>1 Then
			GUICtrlSetData($iMainGui_DetailedLabelTitle,$aData[1][0])
			GUICtrlSetData($iMainGui_DetailedEditDescription,$aData[1][8])
			If StringInStr($aData[1][4],"true") Then
				GUICtrlSetData($iMainGui_DetailedLabelInProduction,"Is in production")
			Else
				GUICtrlSetData($iMainGui_DetailedLabelInProduction,"TV-Show is finished")
			EndIf
			GUICtrlSetData($iMainGui_DetailedLabelLastSeenSeason,"Last seen season: "&$aData[1][5])
			GUICtrlSetData($iMainGui_DetailedLabelLastSeenEpisode,"Last seen episode: "&$aData[1][6])
			$iDetailedInfoRating=Int($aData[1][7])
			$hDetailedInfoBitmapPosterOrig=_GDIPlus_BitmapCreateFromMemory(Binary("0"&$aData[1][9]))
			$iDetailedInfoBitmapPosterOrigWidth=_GDIPlus_ImageGetWidth($hDetailedInfoBitmapPosterOrig)
			$iDetailedInfoBitmapPosterOrigHeight=_GDIPlus_ImageGetHeight($hDetailedInfoBitmapPosterOrig)
			local $sSelect="SELECT g.name FROM Genre g JOIN (SELECT tg.genreId FROM TVShowGenre tg WHERE tg.tvShowId='"&$sSeriesID&"') WHERE g.id=genreId;"
			_SQLite_GetTable2d($hMainDatabase,$sSelect,$aData,$iRows,$iCols)
			For $i=1 To UBound($aData)-1 step 1
				_GUICtrlListBox_AddString($iMainGui_DetailedListGenre,$aData[$i][0])
			Next
			local $sSelect="SELECT MAX(seasonNumber) AS lastSeason,episodeCount AS lastEpisode FROM TVShowSeasonInfo WHERE tvShowId='"&$sSeriesID&"'"
			_SQLite_GetTable2d($hMainDatabase,$sSelect,$aData,$iRows,$iCols)
			GUICtrlSetData($iMainGui_DetailedLabelLatestSeason, "Last published season : "&$aData[1][0])
			GUICtrlSetData($iMainGui_DetailedLabelLatestEpisode,"Last published episode: "&$aData[1][1])
		EndIf
	EndIf
	_updateWinSize($hMainGui)
	WM_PAINT($hMainGui,0,0,0)
EndFunc

Func _updateListviewEntrys()
	AdlibUnRegister("_updateListviewEntrys")
	If $bMainListViewBeingFilled=true Then
		$bMainListViewStopFilling=true
		AdlibRegister("_updateListviewEntrys",250)
		return 0
	EndIf
	$bMainListViewBeingFilled=true
	local $arSelectedGenres=_GUICtrlListBox_GetSelItems($iMainGui_GenreList)
	;$sMainListviewFields="ID|Title|Season count|Episode count|Is in Production|Last season|Last episode|Last seen season|Last seen episode|Rating"
	local $sSelect="SELECT t.id,t.title,t.seasonCount,t.episodeCount,t.inProduction,lastSeason,lastEpisode,u.lastSeenSeason,u.lastSeenEpisode,u.rating FROM (TVShow t JOIN Userdata u ON t.id=u.tvShowId)"& _
						" JOIN (SELECT tssi.tvShowID,MAX(tssi.seasonNumber) AS lastSeason,tssi.episodeCount AS lastEpisode FROM TVShowSeasonInfo tssi GROUP BY tssi.TVShowID) AS tssi ON t.id=tssi.tvShowId "
	If UBound($arSelectedGenres)=2 and _GUICtrlListBox_GetText($iMainGui_GenreList,$arSelectedGenres[1])="All" Then
		$sSelect&="WHERE 1"
	ElseIf UBound($arSelectedGenres)>1 Then
		$sSelect&="WHERE t.id IN (SELECT DISTINCT tg.tvShowId FROM TVShowGenre tg WHERE tg.genreId IN (SELECT g.id FROM Genre g WHERE g.name IN ("
		For $i=1 to UBound($arSelectedGenres)-1 step 1
			$sSelect&="'"&_GUICtrlListBox_GetText($iMainGui_GenreList,$arSelectedGenres[$i])&"'"
			If $i<>UBound($arSelectedGenres)-1 Then
				$sSelect&=","
			EndIf
		next
		$sSelect&=")))"
	EndIf
	If UBound($arSelectedGenres)>1 Then
		local $aData,$aRows,$aCols
		_SQLite_GetTable2d($hMainDatabase,$sSelect,$aData,$aRows,$aCols)
		_GUICtrlListView_BeginUpdate($iMainGui_TVShowList)
		_GUICtrlListView_DeleteAllItems($iMainGui_TVShowList)
		For $i=1 to UBound($aData)-1 step 1
			local $sEntry=""
			For $j=0 to UBound($aData,2)-1 step 1
				$sEntry&=$aData[$i][$j]
				If $j<>UBound($aData,2)-1 Then
					$sEntry&="|"
				EndIf
			Next
			$iLastEntry=GUICtrlCreateListViewItem($sEntry,$iMainGui_TVShowList)
			If Int($aData[$i][7])<Int($aData[$i][5]) or (Int($aData[$i][7])=Int($aData[$i][5]) and Int($aData[$i][8])<Int($aData[$i][6])) Then
				GUICtrlSetBkColor($iLastEntry,0xFFFF00)
			EndIf
			If $bMainListViewStopFilling Then ExitLoop
		Next
		_GUICtrlListView_EndUpdate($iMainGui_TVShowList)
		$bMainListViewStopFilling=false
		$bMainListViewBeingFilled=false
	EndIf
EndFunc

Func _AddEditTVShowMenu()
	_AddEditTVShow("-1")
EndFunc
Func _AddEditTVShow($sEditID="-1")
	If NOT $bAddEditTVShowGuiOpen Then
		$bAddEditTVShowGuiOpen=true
		ReDim $arLastWatchedData[0]
		$arMainWinSize=WinGetPos($hMainGui)
		$hAddEditTVShowGui=GUICreate("Add/Edit TV-Show",$arMainWinSize[2]-$iAddEditTVShowWinDiff*2,$arMainWinSize[3]-$iAddEditTVShowWinDiff*2, _
							$arMainWinSize[0]+$iAddEditTVShowWinDiff,$arMainWinSize[1]+$iAddEditTVShowWinDiff,BitOR($WS_MINIMIZEBOX,$WS_CAPTION,$WS_POPUP,$WS_SYSMENU,$WS_SIZEBOX,$WS_MAXIMIZEBOX),-1,$hMainGui)
		$iAddEditTVShowGui_SearchInput=GUICtrlCreateInput("",5,5)
		$iAddEditTVShowGui_SearchButton=GUICtrlCreateButton("Search",5,5)
		GUICtrlSetOnEvent(-1,"_showSearchResults")
		$iAddEditTVShowGui_AbortSearchButton=GUICtrlCreateButton("Cancel",5,5)
		GUICtrlSetOnEvent(-1,"_closeSearch")
		If NOT $bUseTMDB or $sEditID<>"-1" Then
			GUICtrlSetState($iAddEditTVShowGui_SearchInput,$GUI_DISABLE)
			GUICtrlSetState($iAddEditTVShowGui_SearchButton,$GUI_DISABLE)
			GUICtrlSetState($iAddEditTVShowGui_AbortSearchButton,$GUI_DISABLE)
		EndIf
		$iAddEditTVShowGui_LabelID=GUICtrlCreateLabel("ID",5,5)
		$iAddEditTVShowGui_InputID=GUICtrlCreateInput("",5,5)
		If $sEditID<>"-1" Then
			GUICtrlSetData($iAddEditTVShowGui_InputID,$sEditID)
		EndIf
		GUICtrlSetState($iAddEditTVShowGui_InputID,$GUI_DISABLE)
		$iAddEditTVShowGui_LabelTitle=GUICtrlCreateLabel("Title",5,5)
		$iAddEditTVShowGui_InputTitle=GUICtrlCreateInput("",5,5)
		$iAddEditTVShowGui_LabelSeasonCount=GUICtrlCreateLabel("Seasoncount",5,5)
		$iAddEditTVShowGui_InputSeasonCount=GUICtrlCreateInput("",5,5)
		$iAddEditTVShowGui_LabelEpisodeCount=GUICtrlCreateLabel("Episodecount",5,5)
		$iAddEditTVShowGui_InputEpisodeCount=GUICtrlCreateInput("",5,5)
		$iAddEditTVShowGui_LabelTMDBID=GUICtrlCreateLabel("The Movie DB ID",5,5)
		$iAddEditTVShowGui_CheckTMDBID=GUICtrlCreateCheckbox("edit",5,5)
		GUICtrlSetOnEvent(-1,"_AddEditTVShow_EditTMDBChanged")
		$iAddEditTVShowGui_InputTMDBID=GUICtrlCreateInput("",5,5)
		GUICtrlSetState($iAddEditTVShowGui_InputTMDBID,$GUI_DISABLE)
		$iAddEditTVShowGui_ButtonTMDBID=GUICtrlCreateButton("Update",5,5)
		GUICtrlSetOnEvent(-1,"_AddEditTVShowUpdateWithID")
		GUICtrlSetState($iAddEditTVShowGui_ButtonTMDBID,$GUI_DISABLE)
		$iAddEditTVShowGui_LabelInProduction=GUICtrlCreateLabel("In production",5,5)
		$iAddEditTVShowGui_ComboInProduction=_GUICtrlComboBoxEx_Create($hAddEditTVShowGui,"No|Yes",5,5,1000,1000,BitOR($CBS_DROPDOWNLIST,$WS_VSCROLL))
		$iAddEditTVShowGui_LabelLastSeenSeason=GUICtrlCreateLabel("Last seen Season",5,5)
		$iAddEditTVShowGui_ComboLastSeenSeason=_GUICtrlComboBoxEx_Create($hAddEditTVShowGui,"0",5,5,1000,1000,$CBS_DROPDOWNLIST)
		GUICtrlSetOnEvent($iAddEditTVShowGui_ComboLastSeenSeason,"_AddEditTVShow_SelChangeSeason")
		$iAddEditTVShowGui_LabelLastSeenEpisode=GUICtrlCreateLabel("Last seen Episode",5,5)
		$iAddEditTVShowGui_ComboLastSeenEpisode=_GUICtrlComboBoxEx_Create($hAddEditTVShowGui,"0",5,5,1000,1000,$CBS_DROPDOWNLIST)
		$iAddEditTVShowGui_LabelRating=GUICtrlCreateLabel("Rating",5,5)
		$iAddEditTVShowGui_ComboRating=_GUICtrlComboBoxEx_Create($hAddEditTVShowGui," |1|2|3|4|5",5,5,1000,1000,$CBS_DROPDOWNLIST)
		$iAddEditTVShowGui_LabelDescription=GUICtrlCreateLabel("Description",5,5)
		$iAddEditTVShowGui_EditDescription=GUICtrlCreateEdit("",5,5,5,5,BitOR($ES_MULTILINE,$ES_AUTOVSCROLL))
		$iAddEditTVShowGui_LabelSeasonInfo=GUICtrlCreateLabel("Season episode count",5,5)
		$iAddEditTVShowGui_ListViewSeasonInfo=GUICtrlCreateListView("Season|Episodecount",5,5)
		$iAddEditTVShowGui_ListViewSeasonInfo_Context=GUICtrlCreateContextMenu($iAddEditTVShowGui_ListViewSeasonInfo)
		GUICtrlCreateMenuItem("Delete entry",$iAddEditTVShowGui_ListViewSeasonInfo_Context)
		GUICtrlSetOnEvent(-1,"_AddEditTVShowGui_DeleteSeasonInfoEntry")
		GUICtrlCreateMenuItem("Add entry below this",$iAddEditTVShowGui_ListViewSeasonInfo_Context)
		GUICtrlSetOnEvent(-1,"_AddEditTVShowGui_AddSeasonInfoEntryBelow")
		GUICtrlCreateMenuItem("Add entry above this",$iAddEditTVShowGui_ListViewSeasonInfo_Context)
		GUICtrlSetOnEvent(-1,"_AddEditTVShowGui_AddSeasonInfoEntryAbove")
		$iAddEditTVShowGui_PicPoster=GUICtrlCreatePic("",5,5,5,5,$SS_CENTERIMAGE)
		$iAddEditTVShowGui_LabelPicChange=GUICtrlCreateLabel("Change Pic",5,5)
		$iAddEditTVShowGui_InputPicPathUrl=GUICtrlCreateInput("",5,5)
		GUICtrlSendMsg($iAddEditTVShowGui_InputPicPathUrl, 0x1501, 0, "Pfad oder URL zum Bild. (Windowspfad oder http://... URL)")
		$iAddEditTVShowGui_ButtonPicChange=GUICtrlCreateButton("Change",5,5)
		GUICtrlSetOnEvent($iAddEditTVShowGui_ButtonPicChange,"_AddEditTVShowGui_ChangePosterPic")
		$iAddEditTVShowGui_ButtonPicPathChange=GUICtrlCreateButton("...",5,5)
		GUICtrlSetOnEvent($iAddEditTVShowGui_ButtonPicPathChange,"_AddEditTVShowGui_ChangePosterPicPath")
		$iAddEditTVShowGui_ListGenre=GUICtrlCreateList("",5,5,5,5,BitOr($LBS_SORT, $WS_HSCROLL, $WS_VSCROLL, $WS_BORDER, $LBS_MULTIPLESEL))
		_loadGenresToList($iAddEditTVShowGui_ListGenre)
		$iAddEditTVShowGui_InputGenreAdd=GUICtrlCreateInput("",5,5)
		$iAddEditTVShowGui_ButtonGenreAdd=GUICtrlCreateButton("Add Genre",5,5)
		$iAddEditTVShowGui_ButtonCreateUpdate=GUICtrlCreateButton("Create series entry",5,5)
		GUICtrlSetOnEvent($iAddEditTVShowGui_ButtonCreateUpdate,"_AddEditTVShow_CreateUpdateSeries")
		$iAddEditTVShowGui_ButtonCancel=GUICtrlCreateButton("Cancel creating series entry",5,5)
		GUICtrlSetOnEvent($iAddEditTVShowGui_ButtonCancel,"_winAddNewTVShow_close")
		If $sEditID<>"-1" Then
			GUICtrlSetData($iAddEditTVShowGui_ButtonCreateUpdate,"Update series entry")
			GUICtrlSetData($iAddEditTVShowGui_ButtonCancel,"Cancel editing series entry")
		EndIf
		$hSearchGui=GUICreate("",50,50,-1,-1,BitOR($WS_POPUP,$WS_VSCROLL,$WS_CHILD),BitOR($WS_EX_CLIENTEDGE,$WS_EX_MDICHILD),$hAddEditTVShowGui)
		_GUIScrollBars_Init($hSearchGui)
		_GUIScrollBars_EnableScrollBar($hSearchGui,$SB_VERT)
		_GUIScrollBars_ShowScrollBar($hSearchGui,$SB_VERT,True)
		_GUIScrollBars_ShowScrollBar($hSearchGui,$SB_HORZ,False)
		GUISetState(@SW_HIDE,$hSearchGui)
		GUISetOnEvent($GUI_EVENT_CLOSE,"_winAddNewTVShow_close",$hAddEditTVShowGui)
		_updateWinSize($hAddEditTVShowGui)
		GUISetState(@SW_SHOW,$hAddEditTVShowGui)
		If $sEditID<>"-1" Then _AddEditTVShow_LoadEditSeries($sEditID)
	Else
		WinActivate($hAddEditTVShowGui)
	EndIf
EndFunc

Func _AddEditTVShowGui_DeleteSeasonInfoEntry()
	$iIndex=_GUICtrlListView_GetSelectedIndices($iAddEditTVShowGui_ListViewSeasonInfo)
	If $iIndex<>"" Then
		_GUICtrlListView_DeleteItem($iAddEditTVShowGui_ListViewSeasonInfo,Int($iIndex))
		_AddEditTVShow_UpdateLastWatchedCombos()
	EndIf
EndFunc

Func _AddEditTVShowGui_AddSeasonInfoEntryBelow()
	$iIndex=Int(_GUICtrlListView_GetSelectedIndices($iAddEditTVShowGui_ListViewSeasonInfo))
	If $iIndex<>"" Then
		_GUICtrlListView_InsertItem($iAddEditTVShowGui_ListViewSeasonInfo,_ReadSeasonInfo(),$iIndex+1)
	Else
		GUICtrlCreateListViewItem(_ReadSeasonInfo(),$iAddEditTVShowGui_ListViewSeasonInfo)
	EndIf
	_AddEditTVShow_UpdateLastWatchedCombos()
EndFunc

Func _AddEditTVShowGui_AddSeasonInfoEntryAbove()
	$iIndex=Int(_GUICtrlListView_GetSelectedIndices($iAddEditTVShowGui_ListViewSeasonInfo))
	If $iIndex<>"" Then
		_GUICtrlListView_InsertItem($iAddEditTVShowGui_ListViewSeasonInfo,_ReadSeasonInfo(),$iIndex-1<0?0:$iIndex-1)
	Else
		GUICtrlCreateListViewItem(_ReadSeasonInfo(),$iAddEditTVShowGui_ListViewSeasonInfo)
	EndIf
	_AddEditTVShow_UpdateLastWatchedCombos()
EndFunc

Func _ReadSeasonInfo()
	$arPos=WinGetPos($hAddEditTVShowGui)
	$sSeasonNumber=InputBox("Create new Seasoninfo","Whats the seasonnumber?","0","",150,130,$arPos[0]+$arPos[2]/2-50,$arPos[1]+$arPos[3]/2-50,0,$hAddEditTVShowGui)
	$sEpisodeCount=InputBox("Create new Seasoninfo","How many Episodes has season "&$sSeasonNumber&"?","0","",150,130,$arPos[0]+$arPos[2]/2-50,$arPos[1]+$arPos[3]/2-50,0,$hAddEditTVShowGui)
	return $sSeasonNumber&"|"&$sEpisodeCount
EndFunc

Func _AddEditTVShow_LoadEditSeries($sSeriesID)
	local $aData,$iRows,$iCols
	local $sSelect="SELECT t.title,t.seasonCount,t.episodeCount,t.tmdbId,t.inProduction,u.lastSeenSeason,u.lastSeenEpisode,u.rating,t.description,t.imageBinary FROM TVShow t JOIN Userdata u ON t.id=u.tvShowID WHERE t.id='"&$sSeriesID&"';"
	_SQLite_GetTable2d($hMainDatabase,$sSelect,$aData,$iRows,$iCols)
	If UBound($aData)>1 Then
		GUICtrlSetData($iAddEditTVShowGui_InputID,$sSeriesID)
		GUICtrlSetData($iAddEditTVShowGui_InputTitle,$aData[1][0])
		GUICtrlSetData($iAddEditTVShowGui_InputSeasonCount,$aData[1][1])
		GUICtrlSetData($iAddEditTVShowGui_InputEpisodeCount,$aData[1][2])
		GUICtrlSetData($iAddEditTVShowGui_InputTMDBID,$aData[1][3])
		If StringInStr($aData[1][4],"true") Then
			_GUICtrlComboBoxEx_SetCurSel($iAddEditTVShowGui_ComboInProduction,1)
		Else
			_GUICtrlComboBoxEx_SetCurSel($iAddEditTVShowGui_ComboInProduction,0)
		EndIf
		local $sLastSeenSeason=$aData[1][5],$sLastSeenEpisode=$aData[1][6]
		GUICtrlSetData($iAddEditTVShowGui_EditDescription,$aData[1][8])
		$iRatingIndex=_GUICtrlComboBoxEx_FindStringExact($iAddEditTVShowGui_ComboRating,$aData[1][7])
		If $iRatingIndex>=0 Then _GUICtrlComboBoxEx_SetCurSel($iAddEditTVShowGui_ComboRating,$iRatingIndex)
		_AddEditTVShow_UpdateImage(Binary("0"&$aData[1][9]))
		local $sSelect="SELECT g.name FROM Genre g JOIN (SELECT tg.genreId FROM TVShowGenre tg WHERE tg.tvShowId='"&$sSeriesID&"') WHERE g.id=genreId;"
		_SQLite_GetTable2d($hMainDatabase,$sSelect,$aData,$iRows,$iCols)
		For $i=1 To UBound($aData)-1 step 1
			$iIndex=_GUICtrlListBox_FindString($iAddEditTVShowGui_ListGenre,$aData[$i][0])
			If $iIndex>=0 Then _GUICtrlListBox_SelItemRange($iAddEditTVShowGui_ListGenre,$iIndex,$iIndex,true)
		Next
		local $sSelect="SELECT SeasonNumber,EpisodeCount FROM TVShowSeasonInfo WHERE tvShowId='"&$sSeriesID&"' ORDER BY SeasonNumber ASC;"
		_SQLite_GetTable2d($hMainDatabase,$sSelect,$aData,$iRows,$iCols)
		For $i=1 To UBound($aData)-1 step 1
			GUICtrlCreateListViewItem($aData[$i][0]&"|"&$aData[$i][1],$iAddEditTVShowGui_ListViewSeasonInfo)
		Next
		_AddEditTVShow_UpdateLastWatchedCombos()
		$iLastSeenSeasonIndex=_GUICtrlComboBoxEx_FindStringExact($iAddEditTVShowGui_ComboLastSeenSeason,$sLastSeenSeason)
		If $iLastSeenSeasonIndex>=0 Then _GUICtrlComboBoxEx_SetCurSel($iAddEditTVShowGui_ComboLastSeenSeason,$iLastSeenSeasonIndex)
		_AddEditTVShow_UpdateEpisodeCombo($iLastSeenSeasonIndex)
		$iLastSeenEpisodeIndex=_GUICtrlComboBoxEx_FindStringExact($iAddEditTVShowGui_ComboLastSeenEpisode,$sLastSeenEpisode)
		If $iLastSeenEpisodeIndex>=0 Then _GUICtrlComboBoxEx_SetCurSel($iAddEditTVShowGui_ComboLastSeenEpisode,$iLastSeenEpisodeIndex)
	EndIf
EndFunc

Func _AddEditTVShowGui_ChangePosterPicPath()
	$sFile=FileOpenDialog("Choose Image",@ScriptDir,"Images (*.jpg;*.bmp;*.gif;*.png)",1,"",$hAddEditTVShowGui)
	If NOT ($sFile="" or @error) Then
		GUICtrlSetData($iAddEditTVShowGui_InputPicPathUrl,$sFile)
	EndIf
EndFunc

Func _AddEditTVShowGui_ChangePosterPic()
	$sURI=GUICtrlRead($iAddEditTVShowGui_InputPicPathUrl)
	If StringInStr($sURI,"http://") or StringInStr($sURI,"http://") Then
		$binImage=InetRead($sURI,8)
		If NOT @error Then
			_AddEditTVShow_UpdateImage($binImage)
		Else
			MsgBox(16,"Error","Something went wrong downloading the Image!")
		EndIf
	Else
		If FileExists($sURI) Then
			$hFile=FileOpen($sURI,16)
			If @error Then MsgBox(16,"Error","Something went wrong loading the Image!")
			$binImage=FileRead($hFile)
			If @error Then MsgBox(16,"Error","Something went wrong loading the Image!")
			_AddEditTVShow_UpdateImage($binImage)
			FileClose($hFile)
		Else
			MsgBox(16,"Error","File given by the Path: "&$sURI&" does not exist!")
		EndIf
	EndIf
EndFunc

Func _AddEditTVShow_UpdateImage($sBinaryImage)
	$_AddEditTVShow_binImageData=$sBinaryImage
	local $hBitmap=_GDIPlus_BitmapCreateFromMemory($sBinaryImage)
	local $arPos=ControlGetPos($hAddEditTVShowGui,"",$iAddEditTVShowGui_PicPoster)
	local $iWidth=$arPos[2],$iHeight=$arPos[3]
	local $iBitmapWidth=_GDIPlus_ImageGetWidth($hBitmap)
	local $iBitmapHeight=_GDIPlus_ImageGetHeight($hBitmap)
	$iScale=$iWidth/$iBitmapWidth>$iHeight/$iBitmapHeight?$iHeight/$iBitmapHeight:$iWidth/$iBitmapWidth
	local $hBitmapScaled=_GDIPlus_ImageScale($hBitmap,$iScale,$iScale)
	_GDIPlus_BitmapDispose($hBitmap)
	local $hBitmapGDI=_GDIPlus_BitmapCreateHBITMAPFromBitmap($hBitmapScaled)
	_GDIPlus_BitmapDispose($hBitmapScaled)
	_WinAPI_DeleteObject(_SendMessage(GUICtrlGetHandle($iAddEditTVShowGui_PicPoster),$STM_SETIMAGE,0,$hBitmapGDI))
EndFunc

Func _AddEditTVShow_CreateUpdateSeries()
	local $sSeriesID=GUICtrlRead($iAddEditTVShowGui_InputID)
	local $sTitle=StringReplace(GUICtrlRead($iAddEditTVShowGui_InputTitle),"'","`")
	local $sSeasonCount=GUICtrlRead($iAddEditTVShowGui_InputSeasonCount)
	local $sEpisodeCount=GUICtrlRead($iAddEditTVShowGui_InputEpisodeCount)
	local $sTMDBID=GUICtrlRead($iAddEditTVShowGui_InputTMDBID)
	local $sInProduction
	_GUICtrlComboBoxEx_GetItemText($iAddEditTVShowGui_ComboInProduction,_GUICtrlComboBoxEx_GetCurSel($iAddEditTVShowGui_ComboInProduction),$sInProduction)
	$sInProduction=StringInStr($sInProduction,"yes")?"true":"false"
	local $sLastSeenSeason
	_GUICtrlComboBoxEx_GetItemText($iAddEditTVShowGui_ComboLastSeenSeason,_GUICtrlComboBoxEx_GetCurSel($iAddEditTVShowGui_ComboLastSeenSeason),$sLastSeenSeason)
	local $sLastSeenEpisode
	_GUICtrlComboBoxEx_GetItemText($iAddEditTVShowGui_ComboLastSeenEpisode,_GUICtrlComboBoxEx_GetCurSel($iAddEditTVShowGui_ComboLastSeenEpisode),$sLastSeenEpisode)
	local $sDescription=StringReplace(GUICtrlRead($iAddEditTVShowGui_EditDescription),"'","`")
	local $sRating
	_GUICtrlComboBoxEx_GetItemText($iAddEditTVShowGui_ComboRating,_GUICtrlComboBoxEx_GetCurSel($iAddEditTVShowGui_ComboRating),$sRating)
	If $sSeriesID<>"" Then
		;Update Seriesdata
		_SQLite_Exec($hMainDatabase,"UPDATE TVShow SET Title='"&$sTitle&"',Description='"&$sDescription&"',ImageBinary='"&$_AddEditTVShow_binImageData&"',SeasonCount='"&$sSeasonCount&"',EpisodeCount='"&$sEpisodeCount& _
			"',TMDBID='"&$sTMDBID&"',InProduction='"&$sInProduction&"' WHERE ID='"&$sSeriesID&"';")
		_SQLite_Exec($hMainDatabase,"UPDATE Userdata SET LastSeenSeason='"&$sLastSeenSeason&"',LastSeenEpisode='"&$sLastSeenEpisode&"',Rating='"&$sRating&"' WHERE TVShowID='"&$sSeriesID&"';")
		_SQLite_Exec($hMainDatabase,"DELETE FROM TVShowSeasonInfo WHERE TVShowID='"&$sSeriesID&"'")
		_SQLite_Exec($hMainDatabase,"DELETE FROM TVShowGenre WHERE TVShowID='"&$sSeriesID&"'")
	Else
		local $aResult,$aRows,$aCols
		_SQLite_GetTable($hMainDatabase,"SELECT MAX(ID) FROM TVShow;",$aResult,$aRows,$aCols)
		$sSeriesID=String(Int($aResult[2])+1)
		_SQLite_Exec($hMainDatabase,"INSERT INTO TVShow(ID,Title,Description,ImageBinary,SeasonCount,EpisodeCount,TMDBID,InProduction) "& _
									"VALUES('"&$sSeriesID&"','"&$sTitle&"','"&$sDescription&"','x"&Hex($_AddEditTVShow_binImageData)&"','"&$sSeasonCount&"','"&$sEpisodeCount&"','"&$sTMDBID&"','"&$sInProduction&"')")
		_SQLite_Exec($hMainDatabase,"INSERT INTO Userdata(TVShowID,LastSeenSeason,LastSeenEpisode,Rating) VALUES('"&$sSeriesID&"','"&$sLastSeenSeason&"','"&$sLastSeenEpisode&"','"&$sRating&"')")
	EndIf
	;Save Season/Episodecount
	local $sSeasonUpdateString="BEGIN TRANSACTION;"
	For $i=0 To _GUICtrlListView_GetItemCount($iAddEditTVShowGui_ListViewSeasonInfo)-1 Step 1
		$sSeasonUpdateString&="INSERT INTO TVShowSeasonInfo(TVShowID,SeasonNumber,EpisodeCount) VALUES('"&$sSeriesID&"','"&_GUICtrlListView_GetItemText($iAddEditTVShowGui_ListViewSeasonInfo,$i,0) _
								&"','"&_GUICtrlListView_GetItemText($iAddEditTVShowGui_ListViewSeasonInfo,$i,1)&"');"
	Next
	$sSeasonUpdateString&="COMMIT;"
	_SQLite_Exec($hMainDatabase,$sSeasonUpdateString)
	;Save Genre
	local $arSelectedGenres=_GUICtrlListBox_GetSelItems($iAddEditTVShowGui_ListGenre)
	local $sGenreUpdateString="BEGIN TRANSACTION;"
	For $i=0 to UBound($arSelectedGenres)-1 step 1
		$sGenreUpdateString&="INSERT INTO TVShowGenre(TVShowID,GenreID) SELECT '"&$sSeriesID&"',g.ID FROM Genre g WHERE g.Name='"&_GUICtrlListBox_GetText($iAddEditTVShowGui_ListGenre,$arSelectedGenres[$i])&"';"
	next
	$sGenreUpdateString&="COMMIT;"
	_SQLite_Exec($hMainDatabase,$sGenreUpdateString)
	_winAddNewTVShow_close()
	_updateListviewEntrys()
EndFunc

Func _DeleteTVShowFromDatabase($sSeriesID)
	_SQLite_Exec($hMainDatabase,"DELETE FROM TVShow WHERE ID='"&$sSeriesID&"'")
	_SQLite_Exec($hMainDatabase,"DELETE FROM Userdata WHERE TVShowID='"&$sSeriesID&"'")
	_SQLite_Exec($hMainDatabase,"DELETE FROM TVShowSeasonInfo WHERE TVShowID='"&$sSeriesID&"'")
	_SQLite_Exec($hMainDatabase,"DELETE FROM TVShowGenre WHERE TVShowID='"&$sSeriesID&"'")
	_updateListviewEntrys()
EndFunc

Func _showSearchResults()
	If $bShowSearchResults=true Then
		_clearSearch()
	Else
		GUISetState(@SW_SHOW,$hSearchGui)
		$bShowSearchResults=true
	EndIf
	local $sTitleInput=StringRegExpReplace(GUICtrlRead($iAddEditTVShowGui_SearchInput),"[^a-zA-Z0-9 ]","")
	ConsoleWrite($sTitleInput)
	If $sTitleInput="" Then
		MsgBox(16,"Error","You have to search for SOMETHING."&@crlf&"Errorcode: "&@error)
		return SetError(1,0,-1)
	EndIf
	$oJsonSearchResult=_TMDB_SearchTitle($sTitleInput)
	If @error or NOT Json_IsObject($oJsonSearchResult) Then
		MsgBox(16,"Error","Error reading The Movie Database Information."&@crlf&"Errorcode: "&@error)
		return SetError(2,0,-1)
	EndIf
	$arResults=Json_ObjGet($oJsonSearchResult,"results")
	If @error Then
		MsgBox(48,"Hint","No Results for this Search."&@crlf&"Errorcode: "&@error)
		return SetError(3,0,-1)
	EndIf
	;ConsoleWrite(Json_Encode($oJsonSearchResult, $Json_PRETTY_PRINT, "  ", "\n", "\n", ",")&@CRLF)
	local $iItemCount=0
	;ID,Name,Poster,description,CtrlPic,CtrlName,CtrlDesc,hBitmap,HoverLabel,PosterWidth
	ReDim $arSearchItems[UBound($arResults)][10]
	For $i=0 to UBound($arResults)-1 step 1
		$oJsonItem=$arResults[$i]
		$arSearchItems[$i][0]=Json_ObjGet($oJsonItem,"id")
		$arSearchItems[$i][1]=Json_ObjGet($oJsonItem,"name")
		$arSearchItems[$i][2]=_TMDB_GetImageBinary(StringReplace(Json_ObjGet($oJsonItem,"poster_path"),"\",""))
		$arSearchItems[$i][3]=Json_ObjGet($oJsonItem,"overview")
	Next
	;CreateSearchItems
	GUISwitch($hSearchGui)
	local $tRect=_WinAPI_GetClientRect($hSearchGui)
	local $iWidth=DllStructGetData($tRECT, "Right")-DllStructGetData($tRECT, "Left")
	local $iHeight=DllStructGetData($tRECT, "Bottom")-DllStructGetData($tRECT, "Top")
	;Set the vertical scrolling range and page size
	local $tSCROLLINFO=DllStructCreate($tagSCROLLINFO)
	DllStructSetData($tSCROLLINFO, "fMask",BitOR($SIF_RANGE, $SIF_PAGE)); BitOR($SIF_RANGE, $SIF_PAGE))
	DllStructSetData($tSCROLLINFO, "nMin", 0)
	DllStructSetData($tSCROLLINFO, "nMax", UBound($arSearchItems)-1)
	DllStructSetData($tSCROLLINFO, "nPage", (($iSearchGuiItemHeight+$iSearchGuiItemVertSpace)*UBound($arSearchItems))/$iHeight)
	_GUIScrollBars_SetScrollInfo($hSearchGui,$SB_VERT,$tSCROLLINFO)
	for $i=0 to UBound($arSearchItems)-1 step 1
		local $hBitmap=_GDIPlus_BitmapCreateFromMemory($arSearchItems[$i][2])
		local $iBitmapWidth=_GDIPlus_ImageGetWidth($hBitmap)
		local $iBitmapHeight=_GDIPlus_ImageGetHeight($hBitmap)
		local $iPosterWidth=($iSearchGuiItemHeight/$iBitmapHeight)*$iBitmapWidth
		local $hBitmapScaled=_GDIPlus_ImageScale($hBitmap,($iSearchGuiItemHeight/$iBitmapHeight),($iSearchGuiItemHeight/$iBitmapHeight))
		_GDIPlus_BitmapDispose($hBitmap)
		local $hBitmapGDI=_GDIPlus_BitmapCreateHBITMAPFromBitmap($hBitmapScaled)
		_GDIPlus_BitmapDispose($hBitmapScaled)
		$arSearchItems[$i][8]=GUICtrlCreateLabel("",5,($iSearchGuiItemHeight+$iSearchGuiItemVertSpace)*$i,$iWidth-10,$iSearchGuiItemHeight)
		GUICtrlSetOnEvent(-1,"_searchItemPressed")
		$arSearchItems[$i][4]=GUICtrlCreatePic("",5,($iSearchGuiItemHeight+$iSearchGuiItemVertSpace)*$i,$iPosterWidth,$iSearchGuiItemHeight-5)
		GUICtrlSetOnEvent(-1,"_searchItemPressed")
		_WinAPI_DeleteObject(_SendMessage(GUICtrlGetHandle($arSearchItems[$i][4]),$STM_SETIMAGE,0,$hBitmapGDI))
		$arSearchItems[$i][5]=GUICtrlCreateLabel($arSearchItems[$i][1],$iPosterWidth+10,($iSearchGuiItemHeight+$iSearchGuiItemVertSpace)*$i,$iWidth-10-$iPosterWidth,40)
		GUICtrlSetOnEvent(-1,"_searchItemPressed")
		GUICtrlSetFont(-1,20,700)
		$arSearchItems[$i][6]=GUICtrlCreateEdit($arSearchItems[$i][3],$iPosterWidth+10,($iSearchGuiItemHeight+$iSearchGuiItemVertSpace)*$i+45,$iWidth-10-$iPosterWidth,$iSearchGuiItemHeight-45,BitOR($ES_READONLY,$ES_MULTILINE,$ES_AUTOVSCROLL))
		GUICtrlSetOnEvent(-1,"_searchItemPressed")
		GUICtrlSetFont(-1,15,300)
		$arSearchItems[$i][7]=$hBitmapGDI
		GUICtrlSetCursor($arSearchItems[$i][8],0)
		$arSearchItems[$i][9]=$iPosterWidth
	next
EndFunc

Func _AddEditTVShow_EditTMDBChanged()
	If GuiCtrlRead($iAddEditTVShowGui_CheckTMDBID)=$GUI_CHECKED Then
		GUICtrlSetState($iAddEditTVShowGui_ButtonTMDBID,$GUI_ENABLE)
		GUICtrlSetState($iAddEditTVShowGui_InputTMDBID,$GUI_ENABLE)
	Else
		GUICtrlSetState($iAddEditTVShowGui_ButtonTMDBID,$GUI_DISABLE)
		GUICtrlSetState($iAddEditTVShowGui_InputTMDBID,$GUI_DISABLE)
	EndIf
EndFunc

Func _AddEditTVShowUpdateWithID()
	$sID=GUICtrlRead($iAddEditTVShowGui_InputTMDBID)
	_fillAddNewSeriesWithTMDB_ID($sID)
EndFunc

Func _AddGenreIfAbsent($sGenre)
	$sGenre=StringReplace($sGenre,"'","`")
	If $sGenre="All" Then return SetError(1,0,-1)
	local $aData,$iRows,$iCols
	_SQLite_GetTable($hMainDatabase,"SELECT count(id) FROM Genre;",$aData,$iRows,$iCols)
	local $iCountGenreBefore=$aData[2]
	_SQLite_Exec($hMainDatabase,"INSERT INTO genre(id,name) SELECT '"&$iCountGenreBefore&"','"&$sGenre&"' WHERE NOT EXISTS(SELECT 1 FROM genre WHERE name = '"&$sGenre&"');")
	_SQLite_GetTable($hMainDatabase,"SELECT count(id) FROM Genre;",$aData,$iRows,$iCols)
	If $iCountGenreBefore<>$aData[2] Then
		_GUICtrlListBox_AddString($iMainGui_GenreList,$sGenre)
		If $bAddEditTVShowGuiOpen Then _GUICtrlListBox_AddString($iAddEditTVShowGui_ListGenre,$sGenre)
	EndIf
EndFunc

Func _loadGenresToList($iListCtrl)
	local $aData,$iRows,$iCols
	_SQLite_GetTable($hMainDatabase,"SELECT name FROM Genre;",$aData,$iRows,$iCols)
	For $i=2 to UBound($aData)-1 step 1
		_GUICtrlListBox_AddString($iListCtrl,$aData[$i])
	Next
EndFunc

Func _searchItemPressed()
	For $i=0 to UBound($arSearchItems)-1 step 1
		If $arSearchItems[$i][4]=@GUI_CtrlId or $arSearchItems[$i][5]=@GUI_CtrlId or $arSearchItems[$i][6]=@GUI_CtrlId or $arSearchItems[$i][8]=@GUI_CtrlId Then
			_fillAddNewSeriesWithTMDB_ID($arSearchItems[$i][0])
			ExitLoop
		EndIf
	Next
EndFunc

Func _fillAddNewSeriesWithTMDB_ID($sID)
	$oJsonDetInfo=_TMDB_GetInfo($sID)
	If @error Then
		MsgBox(16,"Error","Error reading The Movie Database Information."&@crlf&"Errorcode: "&@error)
		return SetError(1,0,-1)
	EndIf
	;ConsoleWrite(Json_Encode($oJsonDetInfo, $Json_PRETTY_PRINT, "  ", "\n", "\n", ",")&@CRLF)
	GUICtrlSetData($iAddEditTVShowGui_InputTitle,Json_ObjGet($oJsonDetInfo,"name"))
	GUICtrlSetData($iAddEditTVShowGui_InputSeasonCount,Json_ObjGet($oJsonDetInfo,"number_of_seasons"))
	GUICtrlSetData($iAddEditTVShowGui_InputEpisodeCount,Json_ObjGet($oJsonDetInfo,"number_of_episodes"))
	GUICtrlSetData($iAddEditTVShowGui_InputTMDBID,Json_ObjGet($oJsonDetInfo,"id"))
	If StringCompare(Json_ObjGet($oJsonDetInfo,"in_production"),"false")=0 Then
		_GUICtrlComboBoxEx_SetCurSel($iAddEditTVShowGui_ComboInProduction,0)
	Else
		_GUICtrlComboBoxEx_SetCurSel($iAddEditTVShowGui_ComboInProduction,1)
	EndIf
	;_GUICtrlComboBoxEx_SetCurSel($iAddEditTVShowGui_ComboLastSeenSeason,0)
	;_GUICtrlComboBoxEx_SetCurSel($iAddEditTVShowGui_ComboLastSeenEpisode,0)
	GUICtrlSetData($iAddEditTVShowGui_EditDescription,Json_ObjGet($oJsonDetInfo,"overview"))
	_GUICtrlComboBoxEx_SetCurSel($iAddEditTVShowGui_ComboRating,0)
	local $arSeasons=Json_ObjGet($oJsonDetInfo,"seasons")
	_GUICtrlListView_DeleteAllItems($iAddEditTVShowGui_ListViewSeasonInfo)
	For $i=0 to UBound($arSeasons)-1 step 1
		GUICtrlCreateListViewItem(Json_ObjGet($arSeasons[$i],"season_number")&"|"&Json_ObjGet($arSeasons[$i],"episode_count"),$iAddEditTVShowGui_ListViewSeasonInfo)
	Next
	_AddEditTVShow_UpdateLastWatchedCombos()
	_GUICtrlListBox_SelItemRange($iAddEditTVShowGui_ListGenre,0,_GUICtrlListBox_GetCount($iAddEditTVShowGui_ListGenre)-1,false)
	local $arGenres=Json_ObjGet($oJsonDetInfo,"genres")
	For $i=0 to UBound($arGenres)-1 step 1
		_AddEditTVShow_SelGenre(Json_ObjGet($arGenres[$i],"name"))
	Next
	_closeSearch()
	_AddEditTVShow_UpdateImage(_TMDB_GetImageBinary(StringReplace(Json_ObjGet($oJsonDetInfo,"poster_path"),"\","")))
EndFunc

Func _AddEditTVShow_UpdateLastWatchedCombos()
	ReDim $arLastWatchedData[_GUICtrlListView_GetItemCount($iAddEditTVShowGui_ListViewSeasonInfo)]
	$selSeasonIndex=_GUICtrlComboBoxEx_GetCurSel($iAddEditTVShowGui_ComboLastSeenSeason)
	$selEpisodeIndex=_GUICtrlComboBoxEx_GetCurSel($iAddEditTVShowGui_ComboLastSeenEpisode)
	_clearCombo($iAddEditTVShowGui_ComboLastSeenSeason)
	For $i=0 To _GUICtrlListView_GetItemCount($iAddEditTVShowGui_ListViewSeasonInfo)-1 Step 1
		_GUICtrlComboBoxEx_AddString($iAddEditTVShowGui_ComboLastSeenSeason,_GUICtrlListView_GetItemText($iAddEditTVShowGui_ListViewSeasonInfo,$i,0))
		$arLastWatchedData[$i]=Int(_GUICtrlListView_GetItemText($iAddEditTVShowGui_ListViewSeasonInfo,$i,1))
	Next
	_GUICtrlComboBoxEx_SetCurSel($iAddEditTVShowGui_ComboLastSeenSeason,$selSeasonIndex)
	_AddEditTVShow_SelChangeSeason()
	_GUICtrlComboBoxEx_SetCurSel($iAddEditTVShowGui_ComboLastSeenEpisode,$selSeasonIndex)
EndFunc

Func _AddEditTVShow_SelChangeSeason()
	_AddEditTVShow_UpdateEpisodeCombo(_GUICtrlComboBoxEx_GetCurSel($iAddEditTVShowGui_ComboLastSeenSeason))
EndFunc
Func _AddEditTVShow_UpdateEpisodeCombo($iSeasonIndex)
	_clearCombo($iAddEditTVShowGui_ComboLastSeenEpisode)
	If $iSeasonIndex>=0 and $iSeasonIndex<UBound($arLastWatchedData) Then
		$iEpisodeCount=$arLastWatchedData[$iSeasonIndex]
		For $i=1 to $iEpisodeCount Step 1
			_GUICtrlComboBoxEx_AddString($iAddEditTVShowGui_ComboLastSeenEpisode,$i)
		Next
	EndIf
EndFunc

Func _clearCombo($iComboCtrl)
	_GUICtrlComboBoxEx_BeginUpdate($iComboCtrl)
	while _GUICtrlComboBoxEx_GetCount($iComboCtrl)>0
		_GUICtrlComboBoxEx_DeleteString($iComboCtrl,0)
	WEnd
	_GUICtrlComboBoxEx_EndUpdate($iComboCtrl)
EndFunc

Func _AddEditTVShow_SelGenre($sGenre)
	$gIndex=_GUICtrlListBox_FindString($iAddEditTVShowGui_ListGenre,$sGenre,true)
	If $gIndex=-1 Then
		_AddGenreIfAbsent($sGenre)
		$gIndex=_GUICtrlListBox_FindString($iAddEditTVShowGui_ListGenre,$sGenre,true)
	EndIf
	_GUICtrlListBox_SelItemRange($iAddEditTVShowGui_ListGenre,$gIndex,$gIndex,true)
EndFunc

Func _clearSearch()
	For $i=0 to UBound($arSearchItems)-1 step 1
		GUICtrlDelete($arSearchItems[$i][4])
		GUICtrlDelete($arSearchItems[$i][5])
		GUICtrlDelete($arSearchItems[$i][6])
		_WinAPI_DeleteObject($arSearchItems[$i][7])
		GUICtrlDelete($arSearchItems[$i][8])
	Next
	ReDim $arSearchItems[0][10]
EndFunc

Func _closeSearch()
	$bShowSearchResults=false
	GUISetState(@SW_HIDE,$hSearchGui)
	_clearSearch()
EndFunc

Func _winAddNewTVShow_close()
	_closeSearch()
	GUIDelete($hSearchGui)
	GUIDelete($hAddEditTVShowGui)
	$bAddEditTVShowGuiOpen=false
EndFunc

Func _updateMainGui()
	_updateWinSize($hMainGui)
EndFunc

Func _updateWinSize($hwnd,$iMsg=-1,$iWParam=-1,$iLParam=-1)
	If $hwnd=$hMainGui Then
		local $tRect=_WinAPI_GetClientRect($hMainGui)
		local $iWidth=DllStructGetData($tRECT, "Right")-DllStructGetData($tRECT, "Left")
		local $iHeight=DllStructGetData($tRECT, "Bottom")-DllStructGetData($tRECT, "Top")
		local $iWidthSpace=15
		local $iHeightSpace=10
		local $iMainGui_GenreList_Width=($iWidth-$iWidthSpace)/4>$iMainGui_GenreListWidth?$iMainGui_GenreListWidth:($iWidth-$iWidthSpace)/4
		Local $iDetailedInfoLineHeight=25
		$iMainGui_DetailedInfoWidth=($iWidth-$iWidthSpace)/4
		$iPosterHeight=$iHeight*0.3>300?300:$iHeight*0.4
		$iDetailedInfoX=10+$iWidth-$iWidthSpace-5-$iMainGui_DetailedInfoWidth
		$iStarHeight=$iHeight*0.1>100?100:$iHeight*0.1
		GUICtrlSetPos($iMainGui_GenreList,5,5,$iMainGui_GenreList_Width,$iHeight-$iHeightSpace)
		GUICtrlSetPos($iMainGui_TVShowList,10+$iMainGui_GenreList_Width,5,$iWidth-$iWidthSpace-$iMainGui_GenreList_Width-5-$iMainGui_DetailedInfoWidth,$iHeight-$iHeightSpace)
		GUICtrlSetPos($iMainGui_DetailedLabelTitle,$iDetailedInfoX,15+$iPosterHeight+$iStarHeight,$iMainGui_DetailedInfoWidth,$iDetailedInfoLineHeight)
		GUICtrlSetPos($iMainGui_DetailedLabelInProduction,$iDetailedInfoX,20+$iPosterHeight+$iStarHeight+$iDetailedInfoLineHeight,$iMainGui_DetailedInfoWidth,$iDetailedInfoLineHeight)
		GUICtrlSetPos($iMainGui_DetailedLabelLatestSeason,$iDetailedInfoX,25+$iPosterHeight+$iStarHeight+$iDetailedInfoLineHeight*2,$iMainGui_DetailedInfoWidth,$iDetailedInfoLineHeight)
		GUICtrlSetPos($iMainGui_DetailedLabelLatestEpisode,$iDetailedInfoX,30+$iPosterHeight+$iStarHeight+$iDetailedInfoLineHeight*3,$iMainGui_DetailedInfoWidth,$iDetailedInfoLineHeight)
		GUICtrlSetPos($iMainGui_DetailedLabelLastSeenSeason,$iDetailedInfoX,35+$iPosterHeight+$iStarHeight+$iDetailedInfoLineHeight*4,$iMainGui_DetailedInfoWidth,$iDetailedInfoLineHeight)
		GUICtrlSetPos($iMainGui_DetailedLabelLastSeenEpisode,$iDetailedInfoX,35+$iPosterHeight+$iStarHeight+$iDetailedInfoLineHeight*5,$iMainGui_DetailedInfoWidth,$iDetailedInfoLineHeight)
		GUICtrlSetPos($iMainGui_DetailedEditDescription,$iDetailedInfoX,35+$iPosterHeight+$iStarHeight+$iDetailedInfoLineHeight*6,$iMainGui_DetailedInfoWidth,($iHeight-(35+$iPosterHeight+$iStarHeight+$iDetailedInfoLineHeight*6))/2-5)
		GUICtrlSetPos($iMainGui_DetailedListGenre,$iDetailedInfoX,35+$iPosterHeight+$iStarHeight+$iDetailedInfoLineHeight*6+($iHeight-(35+$iPosterHeight+$iStarHeight+$iDetailedInfoLineHeight*6))/2,$iMainGui_DetailedInfoWidth,($iHeight-(35+$iPosterHeight+$iStarHeight+$iDetailedInfoLineHeight*5))/2-15)
		WM_PAINT($hMainGui,0,0,0)
	ElseIf $hwnd=$hAddEditTVShowGui Then
		local $tRect=_WinAPI_GetClientRect($hAddEditTVShowGui)
		local $iWidth=DllStructGetData($tRECT, "Right")-DllStructGetData($tRECT, "Left")
		local $iHeight=DllStructGetData($tRECT, "Bottom")-DllStructGetData($tRECT, "Top")
		local $iWidthSpace=20
		local $iHeightSpace=15
		local $iSearchHeight=30
		local $iSearchInputWidth=$iWidth-$iWidthSpace-2*$iAddEditNewTVShow_SearchButtonWidth
		;Search
		GUICtrlSetPos($iAddEditTVShowGui_SearchInput,5,5,$iSearchInputWidth,$iSearchHeight-10)
		GUICtrlSetPos($iAddEditTVShowGui_SearchButton,10+$iSearchInputWidth,5,$iAddEditNewTVShow_SearchButtonWidth,$iSearchHeight-10)
		GUICtrlSetPos($iAddEditTVShowGui_AbortSearchButton,15+$iSearchInputWidth+$iAddEditNewTVShow_SearchButtonWidth,5,$iAddEditNewTVShow_SearchButtonWidth,$iSearchHeight-10)
		;DataFields
		local $iLabelWidth=85
		local $iLineHeight=30
		local $iInputWidth=($iWidth-10)*0.75-$iLabelWidth-5
		local $iListWidth=($iWidth-10)*0.25-15
		GUICtrlSetPos($iAddEditTVShowGui_LabelID,5,5+$iSearchHeight,$iLabelWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_InputID,5+$iLabelWidth+5,5+$iSearchHeight,$iInputWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_LabelTitle,5,5+$iSearchHeight+$iLineHeight*1,$iLabelWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_InputTitle,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*1,$iInputWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_LabelSeasonCount,5,5+$iSearchHeight+$iLineHeight*2,$iLabelWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_InputSeasonCount,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*2,$iInputWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_LabelEpisodeCount,5,5+$iSearchHeight+$iLineHeight*3,$iLabelWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_InputEpisodeCount,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*3,$iInputWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_LabelTMDBID,5,5+$iSearchHeight+$iLineHeight*4,$iLabelWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_CheckTMDBID,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*4,50,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_InputTMDBID,5+$iLabelWidth+5+55,5+$iSearchHeight+$iLineHeight*4,$iInputWidth-55-55,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_ButtonTMDBID,5+$iLabelWidth+5+$iInputWidth-50,5+$iSearchHeight+$iLineHeight*4,50,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_LabelInProduction,5,5+$iSearchHeight+$iLineHeight*5,$iLabelWidth,$iLineHeight-5)
		;GUICtrlSetPos(_GUICtrlComboBoxEx_GetComboControl($iAddEditTVShowGui_ComboInProduction),5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*5,$iInputWidth,$iLineHeight-5)
		;WinMove($iAddEditTVShowGui_ComboInProduction,"",5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*5,$iInputWidth,$iLineHeight-5)
		ControlMove($hAddEditTVShowGui,"",$iAddEditTVShowGui_ComboInProduction,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*5,$iInputWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_LabelLastSeenSeason,5,5+$iSearchHeight+$iLineHeight*6,$iLabelWidth,$iLineHeight-5)
		GUICtrlSetPos(_GUICtrlComboBoxEx_GetComboControl($iAddEditTVShowGui_ComboLastSeenSeason),5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*6,$iInputWidth,$iLineHeight-5)
		;WinMove($iAddEditTVShowGui_ComboLastSeenSeason,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*6,$iInputWidth,$iLineHeight-5)
		ControlMove($hAddEditTVShowGui,"",$iAddEditTVShowGui_ComboLastSeenSeason,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*6,$iInputWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_LabelLastSeenEpisode,5,5+$iSearchHeight+$iLineHeight*7,$iLabelWidth,$iLineHeight-5)
		GUICtrlSetPos(_GUICtrlComboBoxEx_GetComboControl($iAddEditTVShowGui_ComboLastSeenEpisode),5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*7,$iInputWidth,$iLineHeight-5)
		;WinMove($iAddEditTVShowGui_ComboLastSeenEpisode,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*7,$iInputWidth,$iLineHeight-5)
		ControlMove($hAddEditTVShowGui,"",$iAddEditTVShowGui_ComboLastSeenEpisode,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*7,$iInputWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_LabelRating,5,5+$iSearchHeight+$iLineHeight*8,$iLabelWidth,$iLineHeight-5)
		GUICtrlSetPos(_GUICtrlComboBoxEx_GetComboControl($iAddEditTVShowGui_ComboRating),5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*8,$iInputWidth,$iLineHeight-5)
		;WinMove($iAddEditTVShowGui_ComboRating,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*8,$iInputWidth,$iLineHeight-5)
		ControlMove($hAddEditTVShowGui,"",$iAddEditTVShowGui_ComboRating,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*8,$iInputWidth,$iLineHeight-5)

		GUICtrlSetPos($iAddEditTVShowGui_LabelPicChange,5,5+$iSearchHeight+$iLineHeight*9,$iLabelWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_InputPicPathUrl,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*9,$iInputWidth-80,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_ButtonPicPathChange,5+$iLabelWidth+5+($iInputWidth-75),5+$iSearchHeight+$iLineHeight*9,20,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_ButtonPicChange,5+$iLabelWidth+5+($iInputWidth-50),5+$iSearchHeight+$iLineHeight*9,50,$iLineHeight-5)

		local $iLeftSpaceHalf=($iHeight-(5+$iSearchHeight+$iLineHeight*10)-10)/2
		GUICtrlSetPos($iAddEditTVShowGui_LabelDescription,5,5+$iSearchHeight+$iLineHeight*10,$iLabelWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_EditDescription,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*10,$iInputWidth,$iLeftSpaceHalf-5)
		GUICtrlSetPos($iAddEditTVShowGui_LabelSeasonInfo,5,5+$iSearchHeight+$iLineHeight*10+5+$iLeftSpaceHalf,$iLabelWidth,$iLineHeight-5)
		GUICtrlSetPos($iAddEditTVShowGui_ListViewSeasonInfo,5+$iLabelWidth+5,5+$iSearchHeight+$iLineHeight*10+5+$iLeftSpaceHalf,$iInputWidth,$iLeftSpaceHalf-40)
		GUICtrlSetPos($iAddEditTVShowGui_ButtonCreateUpdate,5,$iHeight-30,($iLabelWidth+$iInputWidth)/2,25)
		GUICtrlSetPos($iAddEditTVShowGui_ButtonCancel,10+($iLabelWidth+$iInputWidth)/2,$iHeight-30,($iLabelWidth+$iInputWidth)/2,25)

		local $iPosterAreaHeight=($iHeight-$iSearchHeight)/2>250?250:($iHeight-$iSearchHeight)/2
		GUICtrlSetPos($iAddEditTVShowGui_PicPoster,5+$iLabelWidth+5+$iInputWidth+5,5+$iSearchHeight,$iListWidth,$iPosterAreaHeight)

		GUICtrlSetPos($iAddEditTVShowGui_ListGenre,5+$iLabelWidth+5+$iInputWidth+5,5+$iSearchHeight+$iPosterAreaHeight,$iListWidth,$iHeight-$iSearchHeight-40-$iPosterAreaHeight)
		GUICtrlSetPos($iAddEditTVShowGui_InputGenreAdd,5+$iLabelWidth+5+$iInputWidth+5,5+($iHeight-40)+5,$iListWidth-65,20)
		GUICtrlSetPos($iAddEditTVShowGui_ButtonGenreAdd,5+$iLabelWidth+5+$iInputWidth+5+$iListWidth-60,5+($iHeight-40)+5,60,20)

		;SearchItems
		local $arWinPos=WinGetPos($hAddEditTVShowGui)
		WinMove($hSearchGui,"",$arWinPos[0]+DllStructGetData($tRECT, "Left")+5,$arWinPos[1]+DllStructGetData($tRECT, "Top")+60,$iWidth-10,$iHeight-40)
		For $i=0 to UBound($arSearchItems)-1 step 1
			local $iPosterWidth=$arSearchItems[$i][9]
			GUICtrlSetPos($arSearchItems[$i][4],5,($iSearchGuiItemHeight+$iSearchGuiItemVertSpace)*$i,$iPosterWidth,$iSearchGuiItemHeight)
			GUICtrlSetPos($arSearchItems[$i][5],$iPosterWidth+10,($iSearchGuiItemHeight+$iSearchGuiItemVertSpace)*$i,$iWidth-10-$iPosterWidth,40)
			GUICtrlSetPos($arSearchItems[$i][6],$iPosterWidth+10,($iSearchGuiItemHeight+$iSearchGuiItemVertSpace)*$i+45,$iWidth-10-$iPosterWidth,$iSearchGuiItemHeight-45)
			GUICtrlSetPos($arSearchItems[$i][8],0,0)
		Next
	EndIf
EndFunc

Func _init()
	_GDIPlus_Startup()
	_SQLite_Startup($sSqlDllPath)
	If @error Then
		MsgBox(16,"Error","Error at SQLite startup!"&@crlf&"Errorcode: "&@error&@crlf&"DLL-Path:"&$sSqlDllPath)
		exit
	EndIf
	$hMainDatabase=_SQLite_Open($sMainDatabaseFile)
	If @error Then
		MsgBox(16,"Error","Error loading Database!"&@crlf&"Errorcode: "&@error&@crlf&"Database-Path:"&$sMainDatabaseFile)
		exit
	EndIf
	_SQLite_Exec($hMainDatabase,"CREATE TABLE IF NOT EXISTS `TVShow`(`ID` INTERGER PRIMARY KEY,`Title` TEXT,`Description` TEXT,`ImageBinary` BLOB,`SeasonCount` INTEGER,`EpisodeCount` INTEGER,`TMDBID` TEXT,`InProduction` TEXT);")
	_SQLite_Exec($hMainDatabase,"CREATE TABLE IF NOT EXISTS `TVShowGenre`(`TVShowID` INTERGER,`GenreID` INTERGER);")
	_SQLite_Exec($hMainDatabase,"CREATE TABLE IF NOT EXISTS `TVShowSeasonInfo`(`TVShowID` INTERGER,`SeasonNumber` INTERGER,`EpisodeCount` INTERGER);")
	_SQLite_Exec($hMainDatabase,"CREATE TABLE IF NOT EXISTS `Genre`(`ID` INTERGER PRIMARY KEY,`Name` TEXT);")
	_SQLite_Exec($hMainDatabase,"CREATE TABLE IF NOT EXISTS `Userdata`(`TVShowID` INTERGER,`LastSeenSeason` INTERGER,`LastSeenEpisode` INTERGER,`Rating` INTERGER);")
EndFunc

Func _shutdown()
	If $bAddEditTVShowGuiOpen Then _winAddNewTVShow_close()
	_SQLite_Close($hMainDatabase)
	_SQLite_Shutdown()
    _GDIPlus_BrushDispose($hBrushMainGui)
	_GDIPlus_BrushDispose($hBrushMainGuiDefaultColor)
	_GDIPlus_BitmapDispose($hDetailedInfoBitmapPosterOrig)
    _GDIPlus_GraphicsDispose($hGraphicsMainGui)
	_GDIPlus_Shutdown()
	IniWrite($sPathIni,"general","iX",WinGetPos($hMainGui)[0])
	IniWrite($sPathIni,"general","iY",WinGetPos($hMainGui)[1])
	IniWrite($sPathIni,"general","iWidth",WinGetPos($hMainGui)[2])
	IniWrite($sPathIni,"general","iHeight",WinGetPos($hMainGui)[3])
	IniWrite($sPathIni,"general","Maximized",BitAND(WinGetState($hMainGui),32)>0?"true":"false")
	GUIDelete($hMainGui)
	exit
EndFunc

Func WM_VSCROLL($hwnd,$iMsg=-1,$iWParam=-1,$iLParam=-1)
	If $hwnd=$hSearchGui Then
		Local $iScrollCode = BitAND($iWParam, 0x0000FFFF)
		; Get all the vertial scroll bar information
		Local $tSCROLLINFO = _GUIScrollBars_GetScrollInfoEx($hWnd, $SB_VERT)
		$iMin = DllStructGetData($tSCROLLINFO, "nMin")
		$iMax = DllStructGetData($tSCROLLINFO, "nMax")
		$iPage = DllStructGetData($tSCROLLINFO, "nPage")
		; Save the position for comparison later on
		$iPosY = DllStructGetData($tSCROLLINFO, "nPos")
		$iPos = $iPosY
		$iTrackPos = DllStructGetData($tSCROLLINFO, "nTrackPos")
		Switch $iScrollCode
			Case $SB_TOP ; user clicked the HOME keyboard key
				DllStructSetData($tSCROLLINFO, "nPos", $iMin)
			Case $SB_BOTTOM ; user clicked the END keyboard key
				DllStructSetData($tSCROLLINFO, "nPos", $iMax)
			Case $SB_LINEUP ; user clicked the top arrow
				DllStructSetData($tSCROLLINFO, "nPos", $iPos - 1)
			Case $SB_LINEDOWN ; user clicked the bottom arrow
				DllStructSetData($tSCROLLINFO, "nPos", $iPos + 1)
			Case $SB_PAGEUP ; user clicked the scroll bar shaft above the scroll box
				DllStructSetData($tSCROLLINFO, "nPos", $iPos - $iPage)
			Case $SB_PAGEDOWN ; user clicked the scroll bar shaft below the scroll box
				DllStructSetData($tSCROLLINFO, "nPos", $iPos + $iPage)
			Case $SB_THUMBTRACK ; user dragged the scroll box
				DllStructSetData($tSCROLLINFO, "nPos", $iTrackPos)
		EndSwitch
		DllStructSetData($tSCROLLINFO, "fMask", $SIF_POS)
		_GUIScrollBars_SetScrollInfo($hWnd, $SB_VERT, $tSCROLLINFO)
		_GUIScrollBars_GetScrollInfo($hWnd, $SB_VERT, $tSCROLLINFO)
		$iPos = DllStructGetData($tSCROLLINFO, "nPos")
		If ($iPos <> $iPosY) Then
			_GUIScrollBars_ScrollWindow($hWnd,0,($iSearchGuiItemHeight+$iSearchGuiItemVertSpace)*($iPosY-$iPos))
			$iPosY = $iPos
		EndIf
		Return $GUI_RUNDEFMSG
	EndIf
EndFunc

Func WM_COMMAND($hWnd, $iMsg, $wParam, $lParam)
    Local $hWndFrom, $iIDFrom, $iCode, $hMainGui_GenreList
    If Not IsHWnd($iMainGui_GenreList) Then $hMainGui_GenreList = GUICtrlGetHandle($iMainGui_GenreList)
    $hWndFrom = $lParam
    $iIDFrom = BitAND($wParam, 0xFFFF) ; Low Word
    $iCode = BitShift($wParam, 16) ; Hi Word
    Switch $hWndFrom
        Case $iMainGui_GenreList, $hMainGui_GenreList
            Switch $iCode
				Case $LBN_DBLCLK ; Sent when the user double-clicks a string in a list box
					_GUICtrlListBox_SelItemRange($hMainGui_GenreList,0,_GUICtrlListBox_GetCount($hMainGui_GenreList)-1,false)
					_GUICtrlListBox_SelItemRange($hMainGui_GenreList,_GUICtrlListBox_GetCaretIndex($hMainGui_GenreList),_GUICtrlListBox_GetCaretIndex($hMainGui_GenreList),true)
					_updateListviewEntrys()
                Case $LBN_SELCHANGE ; Sent when the selection in a list box has changed
					local $arSelTexts=_GUICtrlListBox_GetSelItems($hMainGui_GenreList)
					local $iAllIsSelected=-1
					For $i=0 to UBound($arSelTexts)-1 step 1
						If _GUICtrlListBox_GetText($hMainGui_GenreList,$arSelTexts[$i])="All" Then $iAllIsSelected=$arSelTexts[$i]
					Next
					If $iAllIsSelected>=0 and _GUICtrlListBox_GetText($hMainGui_GenreList,_GUICtrlListBox_GetCaretIndex($hMainGui_GenreList))="All" Then
						_GUICtrlListBox_SelItemRange($hMainGui_GenreList,0,_GUICtrlListBox_GetCount($hMainGui_GenreList)-1,false)
						_GUICtrlListBox_SelItemRange($hMainGui_GenreList,_GUICtrlListBox_GetCaretIndex($hMainGui_GenreList),_GUICtrlListBox_GetCaretIndex($hMainGui_GenreList),true)
					ElseIf $iAllIsSelected>=0 Then
						_GUICtrlListBox_SelItemRange($hMainGui_GenreList,$iAllIsSelected,$iAllIsSelected,false)
					EndIf
					_updateListviewEntrys()
			EndSwitch
		Case $iAddEditTVShowGui_ComboLastSeenSeason
			Switch $iCode
				case $CBN_SELCHANGE
					$iSelIndex=_GUICtrlComboBoxEx_GetCurSel($iAddEditTVShowGui_ComboLastSeenSeason)
					_AddEditTVShow_UpdateEpisodeCombo($iSelIndex)
			EndSwitch
    EndSwitch
    Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_COMMAND

Func WM_PAINT($hWnd, $iMsg, $wParam, $lParam)
	If $hwnd=$hMainGui Then
		_drawRating($iDetailedInfoX,10+$iPosterHeight,$iMainGui_DetailedInfoWidth,$iStarHeight)
		_drawPoster($iDetailedInfoX,5,$iMainGui_DetailedInfoWidth,$iPosterHeight)
	EndIf
EndFunc

Func WM_NOTIFY($hWnd, $iMsg, $wParam, $lParam)
    Local $hWndFrom, $iIDFrom, $iCode, $tNMHDR, $tInfo
    $tNMHDR = DllStructCreate($tagNMHDR, $lParam)
    $hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
    $iIDFrom = DllStructGetData($tNMHDR, "IDFrom")
    $iCode = DllStructGetData($tNMHDR, "Code")
    Switch $hWndFrom
        Case GUICtrlGetHandle($iMainGui_TVShowList)
            Switch $iCode
                Case $NM_CLICK ; Sent by a list-view control when the user clicks an item with the left mouse button
                    $tInfo = DllStructCreate($tagNMITEMACTIVATE, $lParam)
					_MainGui_ShowDetailedSeriesInfo(_GUICtrlListView_GetItemText($iMainGui_TVShowList,DllStructGetData($tInfo, "Index"),0))
                Case $NM_DBLCLK ; Sent by a list-view control when the user double-clicks an item with the left mouse button
                    $tInfo = DllStructCreate($tagNMITEMACTIVATE, $lParam)
					_AddEditTVShow(_GUICtrlListView_GetItemText($iMainGui_TVShowList,DllStructGetData($tInfo, "Index"),0))
            EndSwitch
    EndSwitch
    Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_NOTIFY


Func _TMDB_GetImageBinary($sID)
	If NOT $bUseTMDB Then return SetError(1,0,-1)
	local $sUrl=StringFormat($sTMDB_GETIMAGE,$sID)
	If @error Then return SetError(2,0,-1)
	local $binImage=InetRead($sUrl,8)
	If @error Then return SetError(3,0,-1)
	return $binImage
EndFunc

Func _TMDB_SearchTitle($sTitle)
	If NOT $bUseTMDB Then return SetError(1,0,-1)
	local $sUrl=StringFormat($sTMDB_SEARCHTVSHOW,_URLEncode($sTitle))
	return _getJsonFromURL($sUrl)
EndFunc

Func _TMDB_GetInfo($sID)
	If NOT $bUseTMDB Then return SetError(1,0,-1)
	local $sUrl=StringFormat($sTMDB_GETTVSHOWINFO,$sID)
	return _getJsonFromURL($sUrl)
EndFunc

Func _getJsonFromURL($sAdress)
	local $binAnswer=InetRead($sAdress)
	If @error Then return SetError(1,0,-1)
	local $sJson = BinaryToString($binAnswer,4)
	If @error Then return SetError(2,0,-1)
	local $oJson=Json_Decode($sJson)
	If @error Then return SetError(3,0,-1)
	return $oJson
EndFunc

Func _URLEncode($sUrlText)
    local $sUrl = ""
    For $i = 1 To StringLen($sUrlText)
        local $aCode = Asc(StringMid($sUrlText, $i, 1))
        If ($aCode >= 48 and $aCode <= 57) or ($aCode >= 65 and $aCode <= 90) or ($aCode >= 97 and $aCode <= 122) Then
			$sUrl=$sUrl&StringMid($sUrlText,$i,1)
		ElseIf $aCode = 32 Then
			$sUrl=$sUrl&"+"
		Else
			$sUrl=$sUrl&"%"&Hex($aCode,2)
        EndIf
    Next
    Return $sUrl
EndFunc   ;==>URLEncode